{ pkgs, lib, ... }:
{

  environment.systemPackages = with pkgs; let

    # to make copilot work
    # jetbrains.pycharm-professional
    fhsPyCharm = pkgs.buildFHSUserEnv {
      name = "pycharm";
      targetPkgs = pkgs: (with pkgs; [
        black
        isort
        #unstable.jetbrains.pycharm-professional
        jetbrains.pycharm-professional
        python311
        pipenv
        zlib # needed for NumPy
        nodejs
        git
      ]);
      runScript = "pycharm-professional";
    };

    # jetbrains.datagrip
    fhsDataGrip = pkgs.buildFHSUserEnv {
      name = "datagrip";
      targetPkgs = pkgs: (with pkgs; [
        unstable.jetbrains.datagrip
      ]);
      runScript = "datagrip";
    };

  in
  [

    # rust development environment
    gcc
    rustup
    unstable.jetbrains.clion

    awscli2

    unstable.mdbook

    overviewer

    openscad
    freecad
    cura

    # record your terminal
    asciinema
    asciinema-agg
    asciinema-scenario
    termtosvg

    # general
    unstable.jetbrains.idea-ultimate
    #vscode

    jetbrains.mps

    fhsDataGrip
    fhsPyCharm
    (pkgs.makeDesktopItem {
      name = "pycharm";
      desktopName = "Python IDE";
      exec = "${fhsPyCharm}/bin/pycharm";
      terminal = false;
    })

    # python
    python3Full
    pipenv

  ];
}
